#include <SPI.h>
const byte chipSelectPin = 9;  // 25xx080 칩을 선택을 하기 위한 핀으로 10번 사용
#define READ  0x03
#define WRITE 0x02
#define WREN 0x06
 
void setup()
{
  int address=0, data = 55; 
  pinMode(chipSelectPin, OUTPUT); // chipSelectPin, 10번 핀을 출력 모드로 설정
  SPI.begin();                     // SPI 통신 준비
  Serial.begin(9600);
  
  //--------- WREN 명령어 전송 -------
  digitalWrite(chipSelectPin, LOW);
  SPI.transfer(WREN); 
  digitalWrite(chipSelectPin, HIGH);
  //----------------------------------
 
  // -------- 주어진 주소에 한 바이트 전송 ----
digitalWrite(chipSelectPin, LOW);     // (CS) ̅ 핀을 LOW로 만들고
  SPI.transfer(WRITE);                      // WRITE 명령을 전송하고 
  SPI.transfer( (byte)(address >> 8) ); // 16비트 어드레스 중 상위 어드레스 8비트 부터 전송 한 후 
  SPI.transfer( (byte) address );          // 하위 어드레스 8비트 전송 
  SPI.transfer(data);                         // 데이터 전송
  digitalWrite(chipSelectPin, HIGH);    // (CS) ̅ 핀을 HIGH로 만듬. 쓰기 끝.
delay(5);                         // 25xx080을 위해서는 5ms 지연 필수 
  //-----------------------------------
 
  Serial.print("Writing Complete....! The value : ");  
  Serial.println(data);
}
void loop()
{
  int address = 0, data;
  //------ 한 바이트 데이터를 주어진 주소에서 읽어 옴 -----
  digitalWrite(chipSelectPin, LOW);    // (CS) ̅ 핀을 LOW로 만들고
  SPI.transfer(READ);                      // READ 명령 전송
  SPI.transfer( (byte)(address >> 8) ); // 16비트 어드레스 중 상위 어드레스 8비트 부터 전송 한 후 
  SPI.transfer( (byte) address );         // 하위 어드레스 8비트 전송 
  data = SPI.transfer(0x00);              // 데이터 읽어 옴
  digitalWrite(chipSelectPin, HIGH);    // (CS) ̅ 핀을 HIGH로 만듬. 읽기 끝.
  //----------------------------------------
  Serial.print("Reading Complete....! The value : ");  // 메모리에서 읽어 온 값을 직렬포트로 출력
  Serial.println(data);
 
  while(1);  // 무한 대기
}

