#include <SoftwareSerial.h>
#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>

SoftwareSerial xBeeSerial(2, 3);
// MAC address from Ethernet shield sticker under board
byte mac[] = {  0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xCB };
EthernetServer server(80);  // create a server at port 80

String strTemperature;
byte Buf[64];

void setup()
{
  
    Serial.begin(9600);       // for debugging
    xBeeSerial.begin(9600);
    Ethernet.begin(mac);  // initialize Ethernet device
    Serial.print("This IP address : ");
    IPAddress ip = Ethernet.localIP();
    Serial.println(ip);
    server.begin();           // start to listen for clients
}

void loop()
{
    char data;
    EthernetClient client = server.available();  // try to get client

   if (client) {  // got client?
        boolean currentLineIsBlank = true;
        while (client.connected()) {
          //--------------------------------------------------------
          while( xBeeSerial.available() ) {
            data = xBeeSerial.read();
            strTemperature += data;
          }
          strTemperature.remove(7);         
          //--------------------------------------------------------
          if (client.available()) {   // client data available to read
            char c = client.read(); // read 1 byte (character) from client
            if (c == '\n' && currentLineIsBlank) {       
                client.println(F("HTTP/1.1 200 OK"));
                client.println(F("Content-Type: text/html"));
                client.println(F("Connection: close"));  
                client.println(F("Refresh: 3"));  
                client.println();
                client.println(F("<!DOCTYPE HTML><html>"));
                client.println(F("<head>"));
                client.println(F("<link rel=\"shortcut icon\" href=\"data:image/x-icon;,\" type=\"image/x-icon\">")); 
                client.println(F("</head><body><center>"));
                client.println(F("<h1> Internet of Things </h1><br>"));            
                client.print(F("Temperature : <font color = red>"));
                client.print(strTemperature);
                Serial.print(strTemperature);
                strTemperature.remove(0);
                client.print(F("</font>  from <font color=blue>TMP36(temperature sensor)</font><br/><br/>"));
                client.println(F("</center></body></html>"));            
                break;
            }
                 
            if (c == '\n') {
              currentLineIsBlank = true;
            } else if (c != '\r') {
              currentLineIsBlank = false;
            }
          }// end if (client.available())
        } // end while (client.connected())
        delay(1);      // give the web browser time to receive the data
        client.stop(); // close the connection
    } // end if (client)
}


