#include <SoftwareSerial.h>
#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>

#define REQ_BUF_SZ   20
SoftwareSerial xBeeSerial(2, 3);
// MAC address from Ethernet shield sticker under board
byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xCB };
EthernetServer server(80);  // create a server at port 80
File webFile;
char HTTP_req[REQ_BUF_SZ] = {0}; // buffered HTTP request stored as null terminated string
char req_index = 0;              // index into HTTP_req buffer
String strTemperature;
byte Buf[64];

void setup()
{

//    pinMode(10, OUTPUT);
 //   digitalWrite(10, HIGH);
    
    Serial.begin(9600);       // for debugging
    xBeeSerial.begin(9600);
    Serial.println(F("Initializing SD card..."));
    if (!SD.begin(4)) {
        Serial.println(F("ERROR - SD card initialization failed!"));
        return;    // init failed
    }
    Serial.println(F("SUCCESS - SD card initialized."));
    Ethernet.begin(mac);  // initialize Ethernet device
    Serial.print("This IP address : ");
    IPAddress ip = Ethernet.localIP();
    Serial.println(ip);

    server.begin();           // start to listen for clients
}

void loop()
{
    int readCount = 0;
    float mVoltage;
    char data;
    EthernetClient client = server.available();  // try to get client

   if (client) {  // got client?
        boolean currentLineIsBlank = true;
        while (client.connected()) {
          //--------------------------------------------------------
          while( xBeeSerial.available() ) {
            data = xBeeSerial.read();
            strTemperature += data;
          }
          strTemperature.remove(7);         
          //--------------------------------------------------------
          if (client.available()) {   // client data available to read
            char c = client.read(); // read 1 byte (character) from client
            if (req_index < (REQ_BUF_SZ - 1)) {
              HTTP_req[req_index] = c;          // save HTTP request character
              req_index++;
            }
            
            if (c == '\n' && currentLineIsBlank) {
              if (StrContains(HTTP_req, "GET / ") || StrContains(HTTP_req, "GET /index.htm")) {                
                client.println(F("HTTP/1.1 200 OK"));
                client.println(F("Content-Type: text/html"));
                client.println(F("Connection: close"));  
                cient.println(F("Refresh: 3"));  
                client.println();
                client.println(F("<!DOCTYPE HTML><html>"));
                client.println(F("<head>"));
                client.println(F("<link rel=\"shortcut icon\" href=\"data:image/x-icon;,\" type=\"image/x-icon\">")); 
                client.println(F("</head><body><center>"));
                client.println(F("<h1> Internet of Things </h1><br>"));
                client.println(F("<img src=\"Ria.jpg\"/><br><h5>file size : 5KB</h5>"));             
                client.print(F("Temperature : <font color = red>"));
                client.print(strTemperature);
                strTemperature="";
                client.print(F("</font>  from <font color=blue>TMP36(temperature sensor)</font><br/><br/>"));
                client.println(F("</center></body></html>"));
              } else if (StrContains(HTTP_req, "GET /Ria.jpg")) {
                webFile = SD.open("Ria.jpg");        // open web page file
                if (webFile) {
                  client.println(F("HTTP/1.1 200 OK"));
                  client.println();
                }
              }
                             
              if (webFile) {
                while( webFile.available() ) {                          
                  readCount = webFile.read(Buf, 64);
                  client.write(Buf, readCount);
                }
                webFile.close();
              }
              req_index = 0;
              StrClear(HTTP_req, REQ_BUF_SZ);
              break;
            }
            
            
            if (c == '\n') {
              currentLineIsBlank = true;
            } else if (c != '\r') {
              currentLineIsBlank = false;
            }
          }// end if (client.available())
        } // end while (client.connected())
        delay(1);      // give the web browser time to receive the data
        client.stop(); // close the connection
    } // end if (client)
}

// sets every element of str to 0 (clears array)
void StrClear(char *str, char length)
{
    for (int i = 0; i < length; i++) {
        str[i] = 0;
    }
}

// searches for the string sfind in the string str
// returns 1 if string found
// returns 0 if string not found
char StrContains(char *str, char *sfind)
{
    char found = 0;
    char index = 0;
    char len;

    len = strlen(str);
    
    if (strlen(sfind) > len) {
        return 0;
    }
    while (index < len) {
        if (str[index] == sfind[found]) {
            found++;
            if (strlen(sfind) == found) {
                return 1;
            }
        }
        else {
            found = 0;
        }
        index++;
    }

    return 0;
}
