#include <SPI.h>
#include <Ethernet.h>

byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xCB };
EthernetServer server(80);  
void setup() {
    Serial.begin(9600);
    Ethernet.begin(mac);  
    Serial.print("This IP address : ");
    IPAddress ip = Ethernet.localIP();
    Serial.println(ip);
    server.begin();                  
}
void loop() {
    EthernetClient client = server.available();  
    if (client) {  
        boolean currentLineIsBlank = true;
        while (client.connected()) { // while - start
            if (client.available()) {   //if - begin
                char c = client.read(); 
                if (c == '\n' && currentLineIsBlank) {
                    makeHTMLPage(client);
                    break;
                }
                if (c == '\n') { currentLineIsBlank = true;  } 
                else if (c != '\r') {  currentLineIsBlank = false;   }
            } // if - end
        } // while - end
        delay(1);      
        client.stop(); 
    } 
}

void makeHTMLPage(EthernetClient client) 
{
   client.println("HTTP/1.1 200 OK");
   client.println("Content-Type: text/html");
   client.println("Connection: close");
   client.println();
   client.println("<!DOCTYPE html>");
   client.println("<html>");
   client.println("<head>");
   client.println("<meta = charset=\"utf-8\">");
   client.println("<title>아두이노 배우기</title>");
   client.println("</head>");
   client.println("<body><center>");
   client.println("<h1>아두이노 배우기 - 사물인터넷 장치 만들기</h1><br>");
   client.println("<font size = 5 color = red > 첫번째 만든 아두이노 웹 서버 </font>");
   client.println("</center></body>");
   client.println("</html>");
   client.println("HTTP/1.1 200 OK");
   client.println("Content-Type: text/html");
   client.println("Connection: close");
   client.println();
   client.println("<!DOCTYPE html>");
   client.println("<html>");
   client.println("<head>");
   client.println("<meta = charset=\"utf-8\">");
   client.println("<title>아두이노 배우기</title>");
   client.println("</head>");
   client.println("<body><center>");
   client.println("<h1>아두이노 배우기 - 사물인터넷 장치 만들기</h1><br>");
   client.println("<font size = 5 color = red > 첫번째 만든 아두이노 웹서버입니다. 홍길동닷컴  </font>");
   client.println("</center></body>");
   client.println("</html>");

}
