#include <SPI.h>
#include <Ethernet.h>

byte mac[] = { 0x90, 0xA2, 0xDA, 0x0D, 0x51, 0x24  };
EthernetServer server(80);  // create a server at port 80

void setup()
{
  Serial.begin(9600);
  Ethernet.begin(mac);
  Serial.print("My IP address: ");  
  Serial.println( Ethernet.localIP() );
  server.begin();
}

void loop()
{
    EthernetClient client = server.available();  
    if ( client ) { 
        boolean currentLineIsBlank = true;
        while ( client.connected() ) {
          if (client.available() ) {
            char c = client.read(); 
            if (c == '\n' && currentLineIsBlank) {
               client.println("HTTP/1.1 200 OK");
               client.println("Content-Type: text/html");
               client.println("Connection: close");
               client.println();                
               client.println("<!DOCTYPE html>");
               client.println("<html>");
               client.println("<head>");
               client.println("<title>Arduino Web Page</title>");
               client.println("</head>");
               client.println("<body>");
               client.println("<h1>Hello from Arduino!</h1>");
               client.println("<p>A web page from the Arduino server</p>");
               client.println("</body>");
               client.println("</html>");
               break;
            }
            if (c == '\n') { currentLineIsBlank = true;  } 
            else if (c != '\r') {  currentLineIsBlank = false;   }
          }
        }
        delay(1);   
        client.stop(); 
    }
}

