#include <SPI.h>
#include <Ethernet.h>
byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xCB };
EthernetServer server(80);  

void setup()
{
    Serial.begin(9600);
    Ethernet.begin(mac); 
    Serial.print("This IP address : ");
    Serial.println( Ethernet.localIP() );
    server.begin();       
    pinMode(2, INPUT);  
}

void loop()
{
    EthernetClient client = server.available();  
    if (client) {  // got client?
        boolean currentLineIsBlank = true;
        while (client.connected()) {
            if (client.available()) {   
                char c = client.read(); 
                if (c == '\n' && currentLineIsBlank) {
                    client.println("HTTP/1.1 200 OK");
                    client.println("Content-Type: text/html");
                    client.println("Connnection: close");
                    client.println();
                    client.println("<!DOCTYPE html>");
                    client.println("<html>");
                    client.println("<head>");
                    client.println("<title>Arduino Read Switch State</title>");
                    client.println("<meta http-equiv=\"refresh\" content=\"1\">");
                    client.println("</head>");
                    client.println("<body>");
                    client.println("<h1>Switch</h1>");
                    client.println("<p>State of switch is:</p>");
                    GetSwitchState(client);
                    client.println("</body>");
                    client.println("</html>");
                    break;
                }
                if (c == '\n') { currentLineIsBlank = true;  } 
                else if (c != '\r') { currentLineIsBlank = false;  }
            } 
        } 
        delay(1);      
        client.stop(); 
    } 
}

void GetSwitchState(EthernetClient cl)
{
    if (digitalRead(2)) {
        cl.println("<p>ON</p>");
    }
    else {
        cl.println("<p>OFF</p>");
    }
}
