#include <SPI.h>
#include <Ethernet.h>
byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xCB };
EthernetServer server(80);

void setup()
{
  Serial.begin(9600);
  Ethernet.begin(mac);
  Serial.print("My IP address: ");  
  Serial.println( Ethernet.localIP() );
  server.begin();
  pinMode(2, INPUT);
}

void loop()
{
  EthernetClient client = server.available();
  if (client) {
    boolean currentLineIsBlank = true;
    while ( client.connected() ) {
      if (client.available()) {
        char c = client.read();
        if (c == '\n' && currentLineIsBlank) {
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println();
          
          if ( digitalRead(2) ) {
            client.println("<html><body> Pressed!</body></html>");
          } else {
            client.println("<html><body>Not Pressed!</body></html>");
          }
          break;
        }

        if (c == '\n') {  currentLineIsBlank = true; } 
        else if (c != '\r') { currentLineIsBlank = false;   }
        
      }
    }
    delay(1);
    client.stop();
  }
}


