#include <SPI.h>
#include <Ethernet.h>
byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xCD };
EthernetServer server(80);  

String HTTP_req;          
boolean LED9_status = 0;   
boolean LED8_status = 0;  

#define LED9_PIN  9
#define LED8_PIN  8

void setup() {
    Serial.begin(9600);
    Ethernet.begin(mac);  
    Serial.print("This IP address : ");
    IPAddress ip = Ethernet.localIP();
    Serial.println(ip);

    server.begin();              
    pinMode(LED9_PIN, OUTPUT);    
    pinMode(LED8_PIN, OUTPUT);    
}

void loop()
{
    EthernetClient client = server.available();  
    if (client) {  
        boolean currentLineIsBlank = true;
        while (client.connected()) {
            if (client.available()) {   
                char c = client.read();
                HTTP_req += c;  
                if (c == '\n' && currentLineIsBlank) {
                    client.println("HTTP/1.1 200 OK");
                    client.println("Content-Type: text/html");
                    client.println("Connection: close");
                    client.println();
                    client.println("<!DOCTYPE html>");
                    
                    client.println("<meta charset=\"utf-8\"/>");
                    //<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, user-scalable=no" />");
                    client.println("<html>");
                    client.println("<head>");
                    client.println("<title>Arduino LED Control</title>");
                    client.println("</head>");
                    client.println("<body>");
                    client.println("<h1><center> 네이버 카페,\"아두이노 배우기\"<br>");
                    client.println("사물인터넷 장치 만들기 - LED 제어</center><br>");
                    client.println("<p>Click to switch LEDs on and off.</p>");
                    client.println("<form method=\"get\">");
                    ProcessCheckbox(client);
                    client.println("</form></h1>");
                    client.println("</body>");
                    client.println("</html>");
                    Serial.print(HTTP_req);
                    HTTP_req = "";    
                    break;
                }
                if (c == '\n') {        currentLineIsBlank = true;      } 
                else if (c != '\r') {   currentLineIsBlank = false;     }
            } 
        } 
        delay(1);    
        client.stop(); 
    } 
}

// switch LED and send back HTML for LED checkbox
void ProcessCheckbox(EthernetClient cl)
{
/*
   Serial.print("HTTP_req.indexOf(\"LED9=1\") -> "); Serial.println( HTTP_req.indexOf("LED9=1") );
   Serial.print("HTTP_req.indexOf(\"LED8=1\") -> "); Serial.println( HTTP_req.indexOf("LED8=1") );
   Serial.print("HTTP_req.indexOf(\"LED9=0\") -> "); Serial.println( HTTP_req.indexOf("LED9=0") );
   Serial.print("HTTP_req.indexOf(\"LED8=0\") -> "); Serial.println( HTTP_req.indexOf("LED8=0") );
*/
    if (HTTP_req.indexOf("LED9=1") > -1 ) {
      LED9_status = ( HTTP_req.indexOf("LED9=1") < 20  ) ? 1 : 0;
    } 

    if (HTTP_req.indexOf("LED8=1") > -1 ) {
      LED8_status = ( HTTP_req.indexOf("LED8=1") < 20  ) ? 1 : 0;
    } 
    
    if (LED9_status) {    // switch LED on
        digitalWrite(LED9_PIN, HIGH);
        cl.println("<input type=\"checkbox\" name=\"LED9\" value=\"1\" onclick=\"submit();\" checked>LED9<br>");
    } else {              
        digitalWrite(LED9_PIN, LOW);
        cl.println("<input type=\"checkbox\" name=\"LED9\" value=\"1\" onclick=\"submit();\">LED9<br>");
    }

    if (LED8_status) {    // switch LED on
        digitalWrite(LED8_PIN, HIGH);
        cl.println("<input type=\"checkbox\" name=\"LED8\" value=\"1\" onclick=\"submit();\" checked>LED8<br>");

    } else {              // switch LED off
        digitalWrite(LED8_PIN, LOW);
        cl.println("<input type=\"checkbox\" name=\"LED8\" value=\"1\" onclick=\"submit();\">LED8<br>");
    }
}
