#include <SPI.h>
#include <Ethernet.h>
byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xC8 };
EthernetServer server(80);  

String HTTP_req;          
boolean LED_status = 0;   
#define LED_PIN  9

void setup() {
    Serial.begin(9600);
    Ethernet.begin(mac);  
    Serial.print("This IP address : ");
    IPAddress ip = Ethernet.localIP();
    Serial.println(ip);

    server.begin();        
    pinMode(LED_PIN, OUTPUT);    
    digitalWrite(LED_PIN, LED_status);
}

void loop()
{
    EthernetClient client = server.available();  
    if (client) {  
        boolean currentLineIsBlank = true;
        while (client.connected()) {
            if (client.available()) {   
                char c = client.read();
                HTTP_req += c;  
                if (c == '\n' && currentLineIsBlank) {
                    client.println("HTTP/1.1 200 OK");
                    client.println("Content-Type: text/html");
                    client.println("Connection: close");
                    client.println();
                    client.println("<!DOCTYPE html>");
                    client.println("<html>");
                    client.println("<head>");
                    client.println("<title>Arduino LED Control</title>");
                    client.println("<link rel=\"shortcut icon\" href=\"data:image/x-icon;,\" type=\"image/x-icon\"> "); 
                    client.println("</head>");
                    client.println("<body>");
                    client.println("<h1>LED");
                    client.println("<p>Click to switch LED on and off.</p>");
                    client.println("<form method=\"get\">");
                    ProcessCheckbox(client);
                    client.println("</form></h1>");
                    client.println("</body>");
                    client.println("</html>");
                    Serial.print(HTTP_req);
                    HTTP_req = "";    
                    break;
                }
                if (c == '\n') {        currentLineIsBlank = true;      } 
                else if (c != '\r') {   currentLineIsBlank = false;     }
            } 
        } 
        delay(1);    
        client.stop(); 
    } 
}

// switch LED and send back HTML for LED checkbox
void ProcessCheckbox(EthernetClient cl)
{
    if (HTTP_req.indexOf("LED9=1") > -1) {  // see if checkbox was clicked
           LED_status = (LED_status == 0 ) ? 1:0;     
    }
    
    digitalWrite(LED_PIN, LED_status);
    
    if (LED_status) {    // switch LED on
        cl.println("<input type=\"checkbox\" name=\"LED9\" value=\"1\" onclick=\"submit();\" checked>LED9");
    } else {              // switch LED off
        cl.println("<input type=\"checkbox\" name=\"LED9\" value=\"1\" onclick=\"submit();\">LED9");
    }
}
