#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>

#define REQ_BUF_SZ   20

byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x67, 0xCB };
EthernetClient client;

EthernetServer server(80);  // create a server at port 80
File webFile;
char HTTP_req[REQ_BUF_SZ] = {0}; // buffered HTTP request stored as null terminated string
char req_index = 0;              // index into HTTP_req buffer

byte Buf[64];

void setup()
{
  
  //  pinMode(10, OUTPUT);
 //   digitalWrite(10, HIGH);
    
    Serial.begin(9600);       // for debugging
    
    // initialize SD card
    Serial.println(F("Initializing SD card..."));
    if (!SD.begin(4)) {
        Serial.println(F("ERROR - SD card initialization failed!"));
        return;    // init failed
    }
    Serial.println(F("SUCCESS - SD card initialized."));
        
    Ethernet.begin(mac);  // initialize Ethernet device
      Serial.print("My IP address: ");
      Serial.println( Ethernet.localIP() );
    
    server.begin();           // start to listen for clients
}

void loop()
{
    int readCount = 0;
    float temperature, mVoltage;
   
    EthernetClient client = server.available();  // try to get client

    if (client) {  // got client?
        boolean currentLineIsBlank = true;
        while (client.connected()) {
            if (client.available()) {   // client data available to read
                char c = client.read(); // read 1 byte (character) from client
                if (req_index < (REQ_BUF_SZ - 1)) {
                    HTTP_req[req_index] = c;          // save HTTP request character
                    req_index++;
                }
               Serial.print(c);
               if (c == '\n' && currentLineIsBlank) {
                    if (StrContains(HTTP_req, "GET / ") || StrContains(HTTP_req, "GET /index.htm")) {                    
                          client.println(F("HTTP/1.1 200 OK"));
                          client.println(F("Content-Type: text/html"));
                          client.println(F("Connection: close"));             	
                          client.println();
                          client.println(F("<!DOCTYPE HTML><html><body><center>"));
                          client.println(F("<h1> Internet of Things </h1><br>"));
                          client.println(F("<img src=\"Ria.jpg\"/><br><h5>file size : 5KB</h5><br>"));                          
                          client.println(F("<img src=\"IoT.jpg\"/><br><h5>file size : 14KB</h5><br>")); 
			  client.println(F("<a href = http://cafe.naver.com/studyonarduino target=_blank><font size = 10 color = BLUE> Study On Arduino</font></a>"));
  		          client.println(F("<br>"));             
                          client.println(F("</center></body></html>"));
                   } else if (StrContains(HTTP_req, "GET /IoT.jpg")) {
                         webFile = SD.open("IoT.jpg");        
                         if (webFile) { client.println(F("HTTP/1.1 200 OK"));   client.println();  }
                   } else if (StrContains(HTTP_req, "GET /Ria.jpg")) {
                         webFile = SD.open("Ria.jpg");        
                         if (webFile) { client.println(F("HTTP/1.1 200 OK"));  client.println();   }                            
                   }
                   if (webFile) {
                        while( webFile.available() ) {                          
                             readCount = webFile.read(Buf, 64);
                             client.write(Buf, readCount);
                        }
                        webFile.close();
                   }
                   req_index = 0;
                   StrClear(HTTP_req, REQ_BUF_SZ);
                   break;
                }
                if (c == '\n') {
                    currentLineIsBlank = true;
                } 
                else if (c != '\r') {
                    // a text character was received from client
                    currentLineIsBlank = false;
                }
            } // end if (client.available())
        } // end while (client.connected())
        delay(1);      // give the web browser time to receive the data
        client.stop(); // close the connection
    } // end if (client)
}

// sets every element of str to 0 (clears array)
void StrClear(char *str, char length)
{
    for (int i = 0; i < length; i++) {
        str[i] = 0;
    }
}

// searches for the string sfind in the string str
// returns 1 if string found
// returns 0 if string not found
char StrContains(char *str, char *sfind)
{
    char found = 0;
    char index = 0;
    char len;

    len = strlen(str);
    
    if (strlen(sfind) > len) {
        return 0;
    }
    while (index < len) {
        if (str[index] == sfind[found]) {
            found++;
            if (strlen(sfind) == found) {
                return 1;
            }
        }
        else {
            found = 0;
        }
        index++;
    }

    return 0;
}
